<?php

namespace Teknisa\MAN\Services;

use Zeedhi\Framework\DTO;
use Doctrine\ORM\EntityManager;

class ParaMensagemKDS {
    
    const CDMENSAGEM = 'CDMENSAGEM';
    const NRORG = 'NRORG';
    const SIZE = 10;
    protected $conn;
    
    public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
    
    public function newRequest(DTO\Request\DataSet $request){
        $nrOrg = $request->getDataSet()->getRows()[0][self::NRORG];
        $request->getDataSet()->getRows()[0]->set(self::CDMENSAGEM, $this->novoCodigo($nrOrg));
        return $request;
    }
    
    private function novoCodigo ($nrOrg){
        $novoCodigo = $this->ultimoCodigo(array(self::NRORG=>$nrOrg));
        return  $novoCodigo !=null ? $novoCodigo : $this->primenroCodigo();
    }
    
    private function primenroCodigo (){
        return str_pad(1, self::SIZE, "0", STR_PAD_LEFT);
    }
    
    private function ultimoCodigo ($param){
        $novoCodigo = $this->entityManager->getConnection()->fetchAll(self::MAX_CODE,$param);
        return $novoCodigo[0][self::CDMENSAGEM];
    }
    
    const MAX_CODE = "
        SELECT MAX(LPAD(RTRIM(TO_CHAR(TO_NUMBER(CDMENSAGEM) + 1)), 10, '0')) AS CDMENSAGEM FROM KDSMENSAGEM WHERE NRORG = :NRORG
    ";
}